import es
import cfglib
import popuplib
import gamethread
import playerlib

info = es.AddonInfo()
info['name'] = "Undead Buy"
info['basename'] = "undead_buy"
info['version'] = "1.3"
info['author'] = "Undead"
info['url'] = "http://forums.mattie.info/cs/forums/viewtopic.php?t=31590"
info['description'] = "Weapon/Item Buy Menu for Players"

es.ServerVar(info['basename'], info['version'], info['description']).makepublic()

itemList = {
  'glock': 400, 'usp': 500, 'p228': 600, 'deagle': 650,
  'fiveseven': 750,  'elite': 800, 'mac10': 1400, 'tmp': 1250,
  'mp5': 1500, 'ump': 1700, 'p90': 2350, 'm3': 1700,
  'xm1014': 3000, 'galil': 2000, 'famas': 2250, 'ak47': 2500,
  'm4a1': 3100, 'sg552': 3500, 'aug': 3500,  'm249': 5750,
  'scout': 2750, 'g3sg1': 5000, 'sg550': 4200, 'awp': 4750,
  'flashbang': 200, 'smokegrenade': 300, 'hegrenade': 300,
  'kevlar': 600, 'assaultsuit': 1000, 'nvgs': 1250, 'defuser': 200
}

catList = {
  'p': 'Pistols:', 'smg': 'Sub-Machine Guns:', 's': 'Shotguns:',
  'r': 'Rifles:', 'mg': 'Machine Guns:', 'sr': 'Sniper Rifles:',
  'g': 'Grenades:', 'm': 'Miscellaneous:'
}

cfg = cfglib.AddonCFG(es.getAddonPath('undead_buy') + '/config.cfg')
buy_cmd = cfg.cvar('ub_buy_cmd', '!buy', 'Commands to open Buy menu')
anywhere = cfg.cvar('ub_anywhere', '0', 'Allows access to menu anywhere on map. 1 = Yes & 0 = Only in Buy Zone.')
anytime = cfg.cvar('ub_anytime', '0', 'Allows access to menu anytime. 1 = Yes & 0 = Based of mp_buytime')
anyteam = cfg.cvar('ub_anyteam', '0', 'Allows which teams can use this. 0 = Both & 1 = Terrorist & 2 = CT')
nadelimit = cfg.cvar('ub_nadelimit', '0', 'How many grenades are allowed purchase of each kind. 0 = Unlimited')
for items in itemList:
  items = cfg.cvar('ub_%s'%items, itemList[items], 'Price for %s'%items)
cfg.write()

popup = {}
dictNades = {}
buyAllowed = False

def load():
  cfg.execute()
  if not es.exists('saycommand', buy_cmd):
    es.regsaycmd(buy_cmd, 'undead_buy/buy_cmd_reg')
  bmenu = popuplib.easymenu('bmenu', '_popup_choice', bmenu_select)
  bmenu.settitle("Buy Menu:")
  for cat in ('p','smg','s','r','mg','sr','g','m'):
    if cat in catList:
      bmenu.addoption(cat, catList[cat].strip(':'))
      popup['%smenu'%cat] = popuplib.easymenu(cat + 'menu', '_popup_choice', weapon_select)
      popup['%smenu'%cat].settitle(catList[cat])
  for items in itemList:
    if not es.exists('clientcommand', 'buy_%s'%items):
      es.regclientcmd('buy_%s'%items, 'undead_buy/buy_client_cmd')
  for items in ('glock','usp','p228','deagle','fiveseven','elite'):
    if items in itemList:
      popup['pmenu'].addoption(items, '%s ($%s)'%(items.capitalize(), int(itemList[items])))
  for items in ['mac10','tmp','mp5','ump','p90']:
    if items in itemList:
      popup['smgmenu'].addoption(items, '%s ($%s)'%(items.capitalize(), int(itemList[items])))
  for items in ['m3','xm1014']:
    if items in itemList:
      popup['smenu'].addoption(items, '%s ($%s)'%(items.capitalize(), int(itemList[items])))
  for items in ['galil','famas','ak47','m4a1','sg552','aug']:
    if items in itemList:
      popup['rmenu'].addoption(items, '%s ($%s)'%(items.capitalize(), int(itemList[items])))
  for items in ['m249']:
    if items in itemList:
      popup['mgmenu'].addoption(items, '%s ($%s)'%(items.capitalize(), int(itemList[items])))
  for items in ['scout','g3sg1','sg550','awp']:
    if items in itemList:
      popup['srmenu'].addoption(items, '%s ($%s)'%(items.capitalize(), int(itemList[items])))
  for items in ['flashbang','smokegrenade','hegrenade']:
    if items in itemList:
      popup['gmenu'].addoption(items, '%s ($%s)'%(items.capitalize(), int(itemList[items])))
  for items in ['kevlar','assaultsuit','nvgs','defuser']:
    if items in itemList:
      popup['mmenu'].addoption(items, '%s ($%s)'%(items.capitalize(), int(itemList[items])))
  if nadelimit > '0':
    for userid in es.getUseridList():
      dictNades_add(userid)
  es.msg('#multi', '#default[#greenUndead Buy#default] by #lightgreenUndead #defaulthas been loaded!')

def unload():
  if es.exists('saycommand', buy_cmd):
    es.unregsaycmd(buy_cmd)
  for items in itemList:
    if es.exists('clientcommand', 'buy_%s'%items):
      es.unregclientcmd('buy_%s'%items)
  for x in ('b','p','smg','s','r','mg','sr','g','m'):
    popuplib.delete(x + 'menu')
  if anytime == '0':
    gamethread.cancelDelayed('disableBuy')
  es.msg('#multi', '#default[#greenUndead Buy#default] by #lightgreenUndead #defaulthas been unloaded!')

def player_spawn(ev):
  userid = ev['userid']
  if nadelimit > '0':
    dictNades_add(userid)

def player_disconnect(ev):
  global dictNades
  userid = ev['userid']
  if nadelimit > '0':
    if userid in dictNades:
      del dictNades[userid]

def round_start(ev):
  global buyAllowed
  if anytime == '0':
    buyAllowed = True
    gamethread.delayedname(float(es.ServerVar('mp_buytime')) * 60, 'disableBuy', disableBuy)
  es.msg('#multi', '#default[#greenUndead Buy#default] Type #lightgreen%s #defaultto access the Buy Menu!'%buy_cmd)

def round_end(ev):
  if anytime == '0':
    gamethread.cancelDelayed('disableBuy')
  if nadelimit > '0':
    for userid in es.getUseridList():
      dictNades_reset(userid)

def disableBuy():
  global buyAllowed
  buyAllowed = False
  for player in es.getUseridList():
    for x in ('b','p','smg','s','r','mg','sr','g','m'):
      if popuplib.isqueued(x + 'menu', player):
        popuplib.unsendname(x + 'menu', player)
        es.tell(player, 'It is too late to buy anything!')

def anyteam_check(userid):
  if anyteam == '0':
    return True
  elif anyteam == '1':
    if es.getplayerteam(userid) == 2:
      return True
  elif anyteam == '2':
    if es.getplayerteam(userid) == 3:
      return True

def buy_cmd_reg():
  userid = es.getcmduserid()
  if anyteam_check(userid):
    if playerlib.getPlayer(userid).inBuyZone() or anywhere == '1':
      if buyAllowed or anytime == '1':
        popuplib.send('bmenu', userid)
      else:
        es.tell(userid, 'It is too late to buy anything!')
    else:
      es.tell(userid, 'You must be in a Buy Zone to use this command.')
  else:
    es.tell(userid, 'You can not use this command on this team.')

def buy_client_cmd():
  userid = es.getcmduserid()
  if anyteam_check(userid):
    if playerlib.getPlayer(userid).inBuyZone() or anywhere == '1':
      if buyAllowed or anytime == '1':
        item = es.getargv(0).strip('buy_')
        if item in itemList:
           price = itemList[item]
           cash_check(userid, price, item)
        else:
          es.tell('Invalid Command or Item Doesn\'t Exists')
      else:
        es.tell(userid, 'It is too late to buy anything!')
    else:
      es.tell(userid, 'You must be in a Buy Zone to use this command.')
  else:
    es.tell(userid, 'You can not use this command on this team.')
 
def cash_check(userid, price, item):
  global dictNades
  player = playerlib.getPlayer(userid)
  if player.cash < price:
    es.tell(userid, '#multi', '#defaultYou can not afford an #green%s #defaultfor #lightgreen$%s#default!'%(item.capitalize(), price))
  else:
    if item not in ['kevlar','assaultsuit','nvgs','defuser']:
      if nadelimit > '0':
        if item in ['hegrenade','flashbang','smokegrenade']:
          dictNades[userid][item] += 1
          if dictNades[userid][item] > nadelimit:
            es.tell(userid, '#multi', '#defaultYou have maxed out your allowed number of #green%s#default\'s.'%item.capitalize())
            return
      es.server.queuecmd('es_xgive %s weapon_%s'%(userid, item))
    else:
      es.server.queuecmd('es_xgive %s item_%s'%(userid, item))
    player.cash -= price
    es.tell(userid, '#multi', '#defaultYou purchased an #green%s #defaultfor #lightgreen$%s#default!'%(item.capitalize(), price))

def dictNades_add(userid):
  global dictNades
  if userid not in dictNades:
    dictNades[userid] = {}
    dictNades[userid]["flashbang"] = 0
    dictNades[userid]["hegrenade"] = 0
    dictNades[userid]["smokegrenade"] = 0

def dictNades_reset(userid):
  global dictNades
  if userid in dictNades:
    dictNades[userid]["flashbang"] = 0
    dictNades[userid]["hegrenade"] = 0
    dictNades[userid]["smokegrenade"] = 0

def bmenu_select(userid, choice, popupid):
  if playerlib.getPlayer(userid).inBuyZone():
    popuplib.send(choice + 'menu', userid)
  else:
    es.tell(userid, 'You must be in a Buy Zone to buy anything!')

def weapon_select(userid, choice, popupid):
  cash_check(userid, int(itemList[choice]), choice)